Index: tests/regression/Filling/SphericalSurface/post/tensid-undo.data
===================================================================
--- tests/regression/Filling/SphericalSurface/post/tensid-undo.data	(revision 57dd40cda8082273cb21c69bba6a7c8b5a561fca)
+++ tests/regression/Filling/SphericalSurface/post/tensid-undo.data	(revision 57dd40cda8082273cb21c69bba6a7c8b5a561fca)
@@ -0,0 +1,59 @@
+# ATOMDATA	Id	name	resName	chainID	x=3	type	neighbors=4	charge
+# Box	20	0	0	0	20	0	0	0	20
+1	NA	SLES	1	8.57749	6.18185	23.6484	NA	0	0	0	0	1	
+2	S	SLES	1	6.82995	9.13426	22.3915	SL	3	4	5	6	1.33	
+3	OS1	SLES	1	7.59547	8.0028	21.4213	OSL	2	7	0	0	-0.28	
+4	OS2	SLES	1	5.84317	8.40868	23.1643	O2L	2	0	0	0	-0.65	
+5	OS3	SLES	1	7.84967	9.66664	23.2709	O2L	2	0	0	0	-0.65	
+6	OS4	SLES	1	6.18974	10.2179	21.6633	O2L	2	0	0	0	-0.65	
+7	C2	SLES	1	7.28013	8.2549	19.987	CC32A	3	8	9	10	-0.11	
+8	H2A	SLES	1	6.16671	8.27034	19.822	HCA2	7	0	0	0	0.09	
+9	H2B	SLES	1	7.70512	9.25609	19.6985	HCA2	7	0	0	0	0.09	
+10	C1	SLES	1	7.94351	7.10644	19.0888	CC32A	7	11	12	13	-0.01	
+11	H1B	SLES	1	7.59106	6.10629	19.4313	HCA2	10	0	0	0	0.09	
+12	H1A	SLES	1	9.05397	7.14679	19.1805	HCA2	10	0	0	0	0.09	
+13	O1	SLES	1	7.69752	7.06775	17.6342	OC30A	10	14	0	0	-0.34	
+14	C2	SLES	1	7.2059	8.28268	17.0302	CC32A	13	15	16	17	-0.01	
+15	H2A	SLES	1	6.2472	8.42857	17.5654	HCA2	14	0	0	0	0.09	
+16	H2B	SLES	1	7.93654	9.04181	17.3897	HCA2	14	0	0	0	0.09	
+17	C1	SLES	1	6.97723	8.46041	15.4961	CC32A	14	18	19	20	-0.01	
+18	H1B	SLES	1	5.93475	8.17418	15.2366	HCA2	17	0	0	0	0.09	
+19	H1A	SLES	1	7.13174	9.52372	15.2239	HCA2	17	0	0	0	0.09	
+20	O1	SLES	1	7.70832	7.69954	14.4815	OC30A	17	21	0	0	-0.34	
+21	C1	SLES	1	7.90467	8.39941	13.1987	CTL2	20	22	23	24	-0.18	
+22	H11	SLES	1	7.27479	9.30707	13.2228	HAL2	21	0	0	0	0.09	
+23	H12	SLES	1	8.96908	8.70282	13.2777	HAL2	21	0	0	0	0.09	
+24	C2	SLES	1	7.66768	7.62565	11.8417	CTL2	21	25	26	27	-0.18	
+25	H21	SLES	1	7.32349	6.59147	12.0671	HAL2	24	0	0	0	0.09	
+26	H22	SLES	1	8.6325	7.55355	11.2935	HAL2	24	0	0	0	0.09	
+27	C3	SLES	1	6.58179	8.34671	10.904	CTL2	24	28	29	30	-0.18	
+28	H31	SLES	1	5.62383	7.78341	10.9615	HAL2	27	0	0	0	0.09	
+29	H32	SLES	1	6.39746	9.37058	11.286	HAL2	27	0	0	0	0.09	
+30	C4	SLES	1	7.03468	8.43723	9.38776	CTL2	27	31	32	33	-0.18	
+31	H41	SLES	1	6.50704	7.65185	8.80732	HAL2	30	0	0	0	0.09	
+32	H42	SLES	1	8.12588	8.2378	9.32029	HAL2	30	0	0	0	0.09	
+33	C5	SLES	1	6.72718	9.86165	8.73873	CTL2	30	34	35	36	-0.18	
+34	H51	SLES	1	5.97341	10.3901	9.36322	HAL2	33	0	0	0	0.09	
+35	H52	SLES	1	7.6603	10.4701	8.7406	HAL2	33	0	0	0	0.09	
+36	C6	SLES	1	6.18521	9.75966	7.26317	CTL2	33	37	38	39	-0.18	
+37	H61	SLES	1	5.1428	9.36986	7.28565	HAL2	36	0	0	0	0.09	
+38	H62	SLES	1	6.1601	10.7806	6.8153	HAL2	36	0	0	0	0.09	
+39	C7	SLES	1	7.05715	8.83021	6.36088	CTL2	36	40	41	42	-0.18	
+40	H71	SLES	1	6.772	7.77129	6.54832	HAL2	39	0	0	0	0.09	
+41	H72	SLES	1	8.12753	8.95224	6.6397	HAL2	39	0	0	0	0.09	
+42	C8	SLES	1	6.89057	9.13653	4.85159	CTL2	39	43	44	45	-0.18	
+43	H81	SLES	1	5.80586	9.23806	4.61813	HAL2	42	0	0	0	0.09	
+44	H82	SLES	1	7.38463	10.1077	4.62071	HAL2	42	0	0	0	0.09	
+45	C9	SLES	1	7.50052	8.03185	3.95272	CTL2	42	46	47	48	-0.18	
+46	H91	SLES	1	7.02693	7.05591	4.20491	HAL2	45	0	0	0	0.09	
+47	H92	SLES	1	8.59002	7.95035	4.1668	HAL2	45	0	0	0	0.09	
+48	C10	SLES	1	7.30225	8.31363	2.44452	CTL2	45	49	50	51	-0.18	
+49	H10	SLES	1	6.2116	8.37202	2.22578	HAL2	48	0	0	0	0.09	
+50	H10	SLES	1	7.75619	9.29965	2.19604	HAL2	48	0	0	0	0.09	
+51	C11	SLES	1	7.94116	7.22096	1.54684	CTL2	48	52	53	54	-0.18	
+52	H11	SLES	1	7.47902	6.23795	1.79433	HAL2	51	0	0	0	0.09	
+53	H11	SLES	1	9.02797	7.15391	1.78194	HAL2	51	0	0	0	0.09	
+54	C12	SLES	1	7.77377	7.4835	0.0277604	CTL3	51	55	56	57	-0.27	
+55	H12	SLES	1	7.22332	6.6439	-0.451223	HAL3	54	0	0	0	0.09	
+56	H12	SLES	1	8.76894	7.57887	-0.459958	HAL3	54	0	0	0	0.09	
+57	H12	SLES	1	7.20436	8.42318	-0.14226	HAL3	54	0	0	0	0.09	
Index: tests/regression/Filling/SphericalSurface/testsuite-molecules-fill-spherical-surface.at
===================================================================
--- tests/regression/Filling/SphericalSurface/testsuite-molecules-fill-spherical-surface.at	(revision 4187a74c602e4565e9e0fb1929d48384d6792cc5)
+++ tests/regression/Filling/SphericalSurface/testsuite-molecules-fill-spherical-surface.at	(revision 57dd40cda8082273cb21c69bba6a7c8b5a561fca)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Fill spherical surface])
-AT_KEYWORDS([molecules fill-spherical-surface rotate-to-principal-axis-system])
+AT_KEYWORDS([molecules filling fill-spherical-surface rotate-to-principal-axis-system])
 
 file=tensid.data
@@ -17,12 +17,12 @@
 AT_SETUP([Molecules - Fill spherical surface with Undo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([molecules fill-spherical-surface undo])
+AT_KEYWORDS([molecules filling fill-spherical-surface rotate-to-principal-axis-system undo])
 
-file=tensid.data
+file=tensid-undo.data
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/pre/tensid.data $file], 0)
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/pre/tensid.potentials .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder --parse-tremolo-potentials tensid.potentials -i $file --select-all-molecules --fill-spherical-surface 200 --position "0,0,10" --radius 50. --undo], 0, [stdout], [stderr])
-AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([../../molecuilder --parse-tremolo-potentials tensid.potentials -i $file --select-all-molecules --rotate-to-principal-axis-system "0,0,-1" --fill-spherical-surface --center "0,0,0" --radius 20. --count 200 --min-distance 3.1 --Alignment-Axis "0,0,1" --undo], 0, [stdout], [stderr])
+AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/post/$file], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -31,5 +31,5 @@
 AT_SETUP([Molecules - Fill spherical surface with Redo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([molecules fill-spherical-surface redo])
+AT_KEYWORDS([molecules filling fill-spherical-surface rotate-to-principal-axis-system redo])
 
 file=tensid.data
@@ -37,5 +37,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/pre/tensid.potentials .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder --parse-tremolo-potentials tensid.potentials -i $file --select-all-molecules --fill-spherical-surface 200 --position "0,0,10" --radius 50. --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder --parse-tremolo-potentials tensid.potentials -i $file --select-all-molecules --rotate-to-principal-axis-system "0,0,-1" --fill-spherical-surface --center "0,0,0" --radius 20. --count 200 --min-distance 3.1 --Alignment-Axis "0,0,1" --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Filling/SphericalSurface/post/tensid.data], 0, [ignore], [ignore])
 