Index: src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.cpp
===================================================================
--- src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.cpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.cpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -48,4 +48,6 @@
 
 #include "CodePatterns/Assert.hpp"
+
+#include <sstream>
 
 #ifdef HAVE_TESTRUNNER
@@ -134,2 +136,22 @@
   CPPUNIT_ASSERT( edge == edge);
 }
+
+
+/** UnitTest for serialization
+ */
+void FragmentEdgeTest::serializeTest()
+{
+  FragmentEdge edge(1,1);
+  // serialize
+  std::stringstream outputstream;
+  boost::archive::text_oarchive oa(outputstream);
+  oa << edge;
+
+  // deserialize
+  FragmentEdge sameedge;
+  std::stringstream returnstream(outputstream.str());
+  boost::archive::text_iarchive ia(returnstream);
+  ia >> sameedge;
+
+  CPPUNIT_ASSERT( edge == sameedge );
+}
Index: src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.hpp
===================================================================
--- src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.hpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/FragmentEdgeUnitTest.hpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -26,4 +26,5 @@
     CPPUNIT_TEST ( comparatorTest );
     CPPUNIT_TEST ( assignmentTest );
+    CPPUNIT_TEST ( serializeTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -33,4 +34,5 @@
       void comparatorTest();
       void assignmentTest();
+      void serializeTest();
 
 };
Index: src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.cpp
===================================================================
--- src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.cpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.cpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -49,4 +49,5 @@
 
 #include "CodePatterns/Assert.hpp"
+#include <sstream>
 
 #ifdef HAVE_TESTRUNNER
@@ -135,2 +136,22 @@
   CPPUNIT_ASSERT( node == node);
 }
+
+
+/** UnitTest for serialization
+ */
+void FragmentNodeTest::serializeTest()
+{
+  FragmentNode node(1,1);
+  // serialize
+  std::stringstream outputstream;
+  boost::archive::text_oarchive oa(outputstream);
+  oa << node;
+
+  // deserialize
+  FragmentNode samenode;
+  std::stringstream returnstream(outputstream.str());
+  boost::archive::text_iarchive ia(returnstream);
+  ia >> samenode;
+
+  CPPUNIT_ASSERT( node == samenode );
+}
Index: src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.hpp
===================================================================
--- src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.hpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/FragmentNodeUnitTest.hpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -26,4 +26,5 @@
     CPPUNIT_TEST ( comparatorTest );
     CPPUNIT_TEST ( assignmentTest );
+    CPPUNIT_TEST ( serializeTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -33,4 +34,5 @@
       void comparatorTest();
       void assignmentTest();
+      void serializeTest();
 };
 
Index: src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.cpp
===================================================================
--- src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.cpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.cpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -51,4 +51,5 @@
 
 #include <boost/assign.hpp>
+#include <sstream>
 
 using namespace boost::assign;
@@ -147,2 +148,23 @@
   CPPUNIT_ASSERT( *graph == *graph);
 }
+
+
+/** UnitTest for serialization
+ */
+void HomologyGraphTest::serializeTest()
+{
+  // serialize
+  std::stringstream outputstream;
+  boost::archive::text_oarchive oa(outputstream);
+  oa << graph;
+
+  // deserialize
+  HomologyGraph *samegraph;
+  std::stringstream returnstream(outputstream.str());
+  boost::archive::text_iarchive ia(returnstream);
+  ia >> samegraph;
+
+  CPPUNIT_ASSERT( *graph == *samegraph );
+
+  delete samegraph;
+}
Index: src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.hpp
===================================================================
--- src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.hpp	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/HomologyGraphUnitTest.hpp	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -29,4 +29,5 @@
     CPPUNIT_TEST ( comparatorTest );
     CPPUNIT_TEST ( assigmentTest );
+    CPPUNIT_TEST ( serializeTest );
     CPPUNIT_TEST_SUITE_END();
 
@@ -36,4 +37,5 @@
       void comparatorTest();
       void assigmentTest();
+      void serializeTest();
 
 private:
Index: src/Fragmentation/Homology/unittests/Makefile.am
===================================================================
--- src/Fragmentation/Homology/unittests/Makefile.am	(revision 77b350d4a59d3e57df0f050138ff3e04048d90f2)
+++ src/Fragmentation/Homology/unittests/Makefile.am	(revision 67db806639ff7456fbd7dd055cd5657502eb2af1)
@@ -28,4 +28,5 @@
 	../libMolecuilderHelpers.la \
 	${CodePatterns_LIBS} \
+  $(BOOST_SERIALIZATION_LDFLAGS) $(BOOST_SERIALIZATION_LIBS) \
 	$(BOOST_LIB)
 
@@ -39,5 +40,5 @@
 	../Fragmentation/Homology/unittests/FragmentNodeUnitTest.hpp
 FragmentNodeUnitTest_LDADD = ${FRAGMENTATIONHOMOLOGYLIBS}
-
+	
 HomologyContainerUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
 	../Fragmentation/Homology/unittests/HomologyContainerUnitTest.cpp \